com.fasterxml.jackson.databind.deser.std

## Class JsonNodeDeserializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonDeserializer<T>
  - - com.fasterxml.jackson.databind.deser.std.StdDeserializer<T>
    - - com.fasterxml.jackson.databind.deser.std.JsonNodeDeserializer

All Implemented Interfaces:
  ContextualDeserializer, NullValueProvider, ValueInstantiator.Gettable, Serializable

    public class JsonNodeDeserializer
    extends StdDeserializer<T>

Deserializer that can build instances of `JsonNode` from any JSON content, using appropriate `JsonNode` type.

Rewritten in Jackson 2.13 to avoid recursion and allow handling of very deeply nested structures.

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonDeserializer

`JsonDeserializer.None`

### Field Summary

Fields
`protected boolean` `_mergeArrays`
`protected boolean` `_mergeObjects`
`protected Boolean` `_supportsUpdates`

### Fields inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

`_valueClass, _valueType, F_MASK_ACCEPT_ARRAYS, F_MASK_INT_COERCIONS`

### Constructor Summary

Constructors
`protected` `JsonNodeDeserializer()`
`protected` `JsonNodeDeserializer(JsonNodeDeserializer base, boolean mergeArrays, boolean mergeObjects)`

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`protected JsonDeserializer<?>` `_createWithMerge(boolean mergeArrays, boolean mergeObjects)`
`protected JsonNode` `_deserializeAnyScalar(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt)`
`protected ContainerNode<?>` `_deserializeContainerNoRecursion(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt, JsonNodeFactory nodeFactory, com.fasterxml.jackson.databind.deser.std.BaseNodeDeserializer.ContainerStack stack, ContainerNode<?> root)`
`protected ObjectNode` `_deserializeObjectAtName(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt, JsonNodeFactory nodeFactory, com.fasterxml.jackson.databind.deser.std.BaseNodeDeserializer.ContainerStack stack)` Alternate deserialization method used when parser already points to first FIELD_NAME and not START_OBJECT.
`protected JsonNode` `_deserializeRareScalar(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt)`
`protected JsonNode` `_fromEmbedded(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt)`
`protected JsonNode` `_fromFloat(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt, JsonNodeFactory nodeFactory)`
`protected JsonNode` `_fromInt(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt, JsonNodeFactory nodeFactory)`
`protected JsonNode` `_fromInt(com.fasterxml.jackson.core.JsonParser p, int coercionFeatures, JsonNodeFactory nodeFactory)`
`protected void` `_handleDuplicateField(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt, JsonNodeFactory nodeFactory, String fieldName, ObjectNode objectNode, JsonNode oldValue, JsonNode newValue)` Method called when there is a duplicate value for a field.
`JsonDeserializer<?>` `createContextual(DeserializationContext ctxt, BeanProperty property)` Method called to see if a different (or differently configured) deserializer is needed to deserialize values of specified property.
`JsonNode` `deserialize(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt)` Implementation that will produce types of any JSON nodes; not just one deserializer is registered to handle (in case of more specialized handler).
`Object` `deserializeWithType(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt, TypeDeserializer typeDeserializer)` Base implementation that does not assume specific type inclusion mechanism.
`Object` `getAbsentValue(DeserializationContext ctxt)` Overridden variant to ensure that absent values are NOT coerced into `NullNode`s, unlike incoming `null` values.
`static JsonDeserializer<? extends JsonNode>` `getDeserializer(Class<?> nodeClass)` Factory method for accessing deserializer for specific node type
`JsonNode` `getNullValue(DeserializationContext ctxt)` Method that can be called to determine value to be used for representing null values (values deserialized when JSON token is `JsonToken.VALUE_NULL`).
`boolean` `isCachable()` Method called to see if deserializer instance is cachable and usable for other properties of same type (type for which instance was created).
`LogicalType` `logicalType()` Method for accessing logical type of values this deserializer produces.
`Boolean` `supportsUpdate(DeserializationConfig config)` Introspection method that may be called to see whether deserializer supports update of an existing value (aka "merging") or not.
`protected JsonNode` `updateObject(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt, ObjectNode node, com.fasterxml.jackson.databind.deser.std.BaseNodeDeserializer.ContainerStack stack)` Alternate deserialization method that is to update existing `ObjectNode` if possible.

### Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

`_byteOverflow, _checkCoercionFail, _checkDoubleSpecialValue, _checkFloatSpecialValue, _checkFloatToIntCoercion, _checkFromStringCoercion, _checkFromStringCoercion, _checkIntToFloatCoercion, _checkTextualNull, _coerceBooleanFromInt, _coercedTypeDesc, _coerceEmptyString, _coerceIntegral, _coerceNullToken, _coerceTextualNull, _deserializeFromArray, _deserializeFromEmpty, _deserializeFromEmptyString, _deserializeFromString, _deserializeWrappedValue, _failDoubleToIntCoercion, _findCoercionFromBlankString, _findCoercionFromEmptyArray, _findCoercionFromEmptyString, _findNullProvider, _hasTextualNull, _intOverflow, _isBlank, _isEmptyOrTextualNull, _isFalse, _isIntNumber, _isNaN, _isNegInf, _isPosInf, _isTrue, _neitherNull, _nonNullNumber, _parseBoolean, _parseBooleanFromInt, _parseBooleanPrimitive, _parseBooleanPrimitive, _parseBytePrimitive, _parseDate, _parseDate, _parseDateFromArray, _parseDouble, _parseDouble, _parseDoublePrimitive, _parseDoublePrimitive, _parseDoublePrimitive, _parseFloatPrimitive, _parseFloatPrimitive, _parseFloatPrimitive, _parseInteger, _parseInteger, _parseIntPrimitive, _parseIntPrimitive, _parseLong, _parseLong, _parseLongPrimitive, _parseLongPrimitive, _parseShortPrimitive, _parseString, _reportFailedNullCoerce, _shortOverflow, _verifyEndArrayForSingle, _verifyNullForPrimitive, _verifyNullForPrimitiveCoercion, _verifyNullForScalarCoercion, _verifyNumberForScalarCoercion, _verifyStringForScalarCoercion, findContentNullProvider, findContentNullStyle, findConvertingContentDeserializer, findDeserializer, findFormatFeature, findFormatOverrides, findValueNullProvider, getValueClass, getValueInstantiator, getValueType, getValueType, handledType, handleMissingEndArrayForSingle, handleNestedArrayForSingle, handleUnknownProperty, isDefaultDeserializer, isDefaultKeyDeserializer`

### Methods inherited from class com.fasterxml.jackson.databind.JsonDeserializer

`deserialize, deserializeWithType, findBackReference, getDelegatee, getEmptyAccessPattern, getEmptyValue, getEmptyValue, getKnownPropertyNames, getNullAccessPattern, getNullValue, getObjectIdReader, replaceDelegatee, unwrappingDeserializer`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### _supportsUpdates

    protected final Boolean _supportsUpdates

#### _mergeArrays

    protected final boolean _mergeArrays

#### _mergeObjects

    protected final boolean _mergeObjects

### Constructor Detail

#### JsonNodeDeserializer

    protected JsonNodeDeserializer()

#### JsonNodeDeserializer

    protected JsonNodeDeserializer(JsonNodeDeserializer base,
                                   boolean mergeArrays,
                                   boolean mergeObjects)

### Method Detail

#### _createWithMerge

    protected JsonDeserializer<?> _createWithMerge(boolean mergeArrays,
                                                   boolean mergeObjects)

#### getDeserializer

    public static JsonDeserializer<? extends JsonNode> getDeserializer(Class<?> nodeClass)

Factory method for accessing deserializer for specific node type

#### getNullValue

    public JsonNode getNullValue(DeserializationContext ctxt)

Description copied from class: `JsonDeserializer`
Method that can be called to determine value to be used for representing null values (values deserialized when JSON token is `JsonToken.VALUE_NULL`). Usually this is simply Java null, but for some types (especially primitives) it may be necessary to use non-null values.

This method may be called once, or multiple times, depending on what `JsonDeserializer.getNullAccessPattern()` returns.

Default implementation simply returns null.

Specified by:
  `getNullValue` in interface `NullValueProvider`
Overrides:
  `getNullValue` in class `JsonDeserializer<JsonNode>`

#### getAbsentValue

    public Object getAbsentValue(DeserializationContext ctxt)

Overridden variant to ensure that absent values are NOT coerced into `NullNode`s, unlike incoming `null` values.

Specified by:
  `getAbsentValue` in interface `NullValueProvider`
Overrides:
  `getAbsentValue` in class `JsonDeserializer<JsonNode>`

#### deserialize

    public JsonNode deserialize(com.fasterxml.jackson.core.JsonParser p,
                                DeserializationContext ctxt)
                         throws IOException

Implementation that will produce types of any JSON nodes; not just one deserializer is registered to handle (in case of more specialized handler). Overridden by typed sub-classes for more thorough checking

Specified by:
  `deserialize` in class `JsonDeserializer<JsonNode>`
Parameters:
  `p` - Parsed used for reading JSON content
  `ctxt` - Context that can be used to access information about this deserialization activity.
Returns:
  Deserialized value
Throws:
  `IOException`

#### supportsUpdate

    public Boolean supportsUpdate(DeserializationConfig config)

Description copied from class: `JsonDeserializer`
Introspection method that may be called to see whether deserializer supports update of an existing value (aka "merging") or not. Return value should either be `Boolean.FALSE` if update is not supported at all (immutable values); `Boolean.TRUE` if update should usually work (regular POJOs, for example), or `null` if this is either not known, or may sometimes work.

Information gathered is typically used to either prevent merging update for property (either by skipping, if based on global defaults; or by exception during deserializer construction if explicit attempt made) if `Boolean.FALSE` returned, or inclusion if `Boolean.TRUE` is specified. If "unknown" case (`null` returned) behavior is to exclude property if global defaults used; or to allow if explicit per-type or property merging is defined.

Default implementation returns `null` to allow explicit per-type or per-property attempts.

#### deserializeWithType

    public Object deserializeWithType(com.fasterxml.jackson.core.JsonParser p,
                                      DeserializationContext ctxt,
                                      TypeDeserializer typeDeserializer)
                               throws IOException

Description copied from class: `StdDeserializer`
Base implementation that does not assume specific type inclusion mechanism. Sub-classes are expected to override this method if they are to handle type information.

Overrides:
  `deserializeWithType` in class `StdDeserializer<T extends JsonNode>`
  `typeDeserializer` - Deserializer to use for handling type information
Throws:
  `IOException`

#### logicalType

    public LogicalType logicalType()

Description copied from class: `JsonDeserializer`
Method for accessing logical type of values this deserializer produces. Typically used for further configuring handling of values, for example, to find which coercions are legal.

Overrides:
  `logicalType` in class `JsonDeserializer<T extends JsonNode>`
Returns:
  Logical type of values this deserializer produces, if known; `null` if not

#### isCachable

    public boolean isCachable()

Description copied from class: `JsonDeserializer`
Method called to see if deserializer instance is cachable and usable for other properties of same type (type for which instance was created).

Note that cached instances are still resolved on per-property basis, if instance implements `ResolvableDeserializer`: cached instance is just as the base. This means that in most cases it is safe to cache instances; however, it only makes sense to cache instances if instantiation is expensive, or if instances are heavy-weight.

Default implementation returns false, to indicate that no caching is done.

Overrides:
  `isCachable` in class `JsonDeserializer<T extends JsonNode>`

#### createContextual

    public JsonDeserializer<?> createContextual(DeserializationContext ctxt,
                                                BeanProperty property)
                                         throws JsonMappingException

Description copied from interface: `ContextualDeserializer`
Method called to see if a different (or differently configured) deserializer is needed to deserialize values of specified property. Note that instance that this method is called on is typically shared one and as a result method should NOT modify this instance but rather construct and return a new instance. This instance should only be returned as-is, in case it is already suitable for use.

Specified by:
  `createContextual` in interface `ContextualDeserializer`
Parameters:
  `ctxt` - Deserialization context to access configuration, additional deserializers that may be needed by this deserializer
  `property` - Method, field or constructor parameter that represents the property (and is used to assign deserialized value). Should be available; but there may be cases where caller cannot provide it and null is passed instead (in which case impls usually pass 'this' deserializer as is)
Returns:
  Deserializer to use for deserializing values of specified property; may be this instance or a new instance.
Throws:
  `JsonMappingException`

#### _handleDuplicateField

    protected void _handleDuplicateField(com.fasterxml.jackson.core.JsonParser p,
                                         DeserializationContext ctxt,
                                         JsonNodeFactory nodeFactory,
                                         String fieldName,
                                         ObjectNode objectNode,
                                         JsonNode oldValue,
                                         JsonNode newValue)
                                  throws IOException

Method called when there is a duplicate value for a field. By default we don't care, and the last value is used. Can be overridden to provide alternate handling, such as throwing an exception, or choosing different strategy for combining values or choosing which one to keep.

Parameters:
  `fieldName` - Name of the field for which duplicate value was found
  `objectNode` - Object node that contains values
  `oldValue` - Value that existed for the object node before newValue was added
  `newValue` - Newly added value just added to the object node
Throws:
  `IOException`

#### _deserializeObjectAtName

    protected final ObjectNode _deserializeObjectAtName(com.fasterxml.jackson.core.JsonParser p,
                                                        DeserializationContext ctxt,
                                                        JsonNodeFactory nodeFactory,
                                                        com.fasterxml.jackson.databind.deser.std.BaseNodeDeserializer.ContainerStack stack)
                                                 throws IOException

Alternate deserialization method used when parser already points to first FIELD_NAME and not START_OBJECT.

Throws:
  `IOException`

#### updateObject

    protected final JsonNode updateObject(com.fasterxml.jackson.core.JsonParser p,
                                          DeserializationContext ctxt,
                                          ObjectNode node,
                                          com.fasterxml.jackson.databind.deser.std.BaseNodeDeserializer.ContainerStack stack)
                                   throws IOException

Alternate deserialization method that is to update existing `ObjectNode` if possible.

Throws:
  `IOException`
Since:
  2.9

#### _deserializeContainerNoRecursion

    protected final ContainerNode<?> _deserializeContainerNoRecursion(com.fasterxml.jackson.core.JsonParser p,
                                                                      DeserializationContext ctxt,
                                                                      JsonNodeFactory nodeFactory,
                                                                      com.fasterxml.jackson.databind.deser.std.BaseNodeDeserializer.ContainerStack stack,
                                                                      ContainerNode<?> root)
                                                               throws IOException

Throws:
  `IOException`

#### _deserializeAnyScalar

    protected final JsonNode _deserializeAnyScalar(com.fasterxml.jackson.core.JsonParser p,
                                                   DeserializationContext ctxt)
                                            throws IOException

Throws:
  `IOException`

#### _deserializeRareScalar

    protected final JsonNode _deserializeRareScalar(com.fasterxml.jackson.core.JsonParser p,
                                                    DeserializationContext ctxt)
                                             throws IOException

Throws:
  `IOException`

#### _fromInt

    protected final JsonNode _fromInt(com.fasterxml.jackson.core.JsonParser p,
                                      int coercionFeatures,
                                      JsonNodeFactory nodeFactory)
                               throws IOException

Throws:
  `IOException`

#### _fromInt

    protected final JsonNode _fromInt(com.fasterxml.jackson.core.JsonParser p,
                                      DeserializationContext ctxt,
                                      JsonNodeFactory nodeFactory)
                               throws IOException

Throws:
  `IOException`

#### _fromFloat

    protected final JsonNode _fromFloat(com.fasterxml.jackson.core.JsonParser p,
                                        DeserializationContext ctxt,
                                        JsonNodeFactory nodeFactory)
                                 throws IOException

Throws:
  `IOException`

#### _fromEmbedded

    protected final JsonNode _fromEmbedded(com.fasterxml.jackson.core.JsonParser p,
                                           DeserializationContext ctxt)
                                    throws IOException

Throws:
  `IOException`